<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Admin Dashboard Template</title>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  <!-- overlayScrollbars -->
  <link rel="stylesheet" href="plugins/overlayScrollbars/css/OverlayScrollbars.min.css">
</head>

<body class="hold-transition sidebar-mini layout-fixed">
  <div class="wrapper">
    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light">
      <!-- Left navbar links -->
      <ul class="navbar-nav">
        <li class="nav-item">
          <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="index3.html" class="nav-link">Home</a>
        </li>
        <li class="nav-item d-none d-sm-inline-block">
          <a href="#" class="nav-link">Contact</a>
        </li>
      </ul>
    </nav>
    <!-- /.navbar -->

    <!-- Main Sidebar Container -->
    <aside class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Brand Logo -->
      <a href="index3.html" class="brand-link">
        <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
          style="opacity: .8">
        <span class="brand-text font-weight-light">DEVCAMP 120</span>
      </a>

      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user panel (optional) -->
        <div class="user-panel mt-3 pb-3 mb-3 d-flex">
          <div class="image">
            <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
          </div>
          <div class="info">
            <a href="#" class="d-block">Đức Hậu</a>
          </div>
        </div>



        <!-- Sidebar Menu -->
        <nav class="mt-2">
          <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
            <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
            <li class="nav-item menu-open">
              <a href="#" class="nav-link active">
                <i class="nav-icon fas fa-tachometer-alt"></i>
                <p>
                  Dashboard
                  <i class="right fas fa-angle-left"></i>
                </p>
              </a>
              <ul class="nav nav-treeview">
                <li class="nav-item">
                  <a href="./index.html" class="nav-link active">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Task 45.30</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="./index2.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Dashboard v2</p>
                  </a>
                </li>
                <li class="nav-item">
                  <a href="./index3.html" class="nav-link">
                    <i class="far fa-circle nav-icon"></i>
                    <p>Dashboard v3</p>
                  </a>
                </li>
              </ul>
            </li>

          </ul>
        </nav>
        <!-- /.sidebar-menu -->
      </div>
      <!-- /.sidebar -->
    </aside>

    <!-- Content Wrapper. Contains page content -->
    <div class="content-wrapper">
      <!-- Content Header (Page header) -->
      <div class="content-header">
        <div class="container-fluid">
          <div class="row mb-2">
            <div class="col-sm-6">
              <h1 class="m-0">F120 - Quản trị Voucher</h1>
            </div><!-- /.col -->
            <div class="col-sm-6">
              <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="#">Home</a></li>
                <li class="breadcrumb-item active">Task 45.30</li>
              </ol>
            </div><!-- /.col -->
          </div><!-- /.row -->
        </div><!-- /.container-fluid -->
      </div>
      <!-- /.content-header -->

      <!-- Main content -->
      <section class="content">
        <div class="container-fluid">
          <div class="form-group">
            <button class="btn btn-success" id="btn-add-voucher"><i class="fa fa-plus"></i>&nbsp; New voucher</button>
          </div>
          <table class="table table-bordered table-striped table-hover" id="voucher-table">
            <thead>
              <tr>
                <th>STT</th>
                <th>ID</th>
                <th>Mã Voucher</th>
                <th>% giảm giá</th>
                <th>Action</th>
              </tr>
            </thead>
          </table>
        </div><!-- /.container-fluid -->
      </section>

      <!-- Modal user detail-->
      <!-- Add/edit voucher modal -->
      <div>
        <div id="voucher-modal" class="modal fade" tabindex="-1">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title" id="h5-modal-title">Voucher information</h5>
                <button class="close" data-dismiss="modal">&times;</button>
              </div>
              <div class="modal-body">
                <form>
                  <div class="row form-group">
                    <div class="col-sm-4">
                      <label for="input-voucher-code">Voucher code</label>
                    </div>
                    <div class="col-sm-8">
                      <input type="text" id="input-voucher-code" name="vouchercodes" placeholder="Voucher code"
                        class="form-control">
                    </div>
                  </div>
                  <div class="row form-group">
                    <div class="col-sm-4">
                      <label for="input-discount">Discount</label>
                    </div>
                    <div class="col-sm-8">
                      <input type="number" id="input-discount" name="discount" placeholder="Discount"
                        class="form-control">
                    </div>
                  </div>
                </form>
              </div>
              <div class="modal-footer">
                <button class="btn btn-secondary" id="btn-cancel" data-dismiss="modal">Cancel</button>
                <button class="btn btn-primary" id="btn-save-voucher">Save Data</button>
              </div>
            </div>
          </div>
        </div>
      </div>

      <!-- Delete confirm modal -->
      <div>
        <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
          <div class="modal-dialog">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title" id="h5-modal-title">Voucher Delete Confirmation</h5>
                <button class="close" data-dismiss="modal">&times;</button>
              </div>
              <div class="modal-body">
                <label>Bạn có chắc chắn muốn xóa voucher này không?</label>
              </div>
              <div class="modal-footer">
                <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                <button class="btn btn-danger" id="btn-confirm-delete-voucher">Confirm</button>
              </div>
            </div>
          </div>
        </div>
      </div>
      <!-- /.content -->
    </div>
    <!-- /.content-wrapper -->
    <footer class="main-footer">
      <strong>IronHack &copy;2022 <a href="https://adminlte.io">DEVCAMP 120</a>.</strong>
      All rights reserved.
      <div class="float-right d-none d-sm-inline-block">
        <b>Version</b> 0.0.1
      </div>
    </footer>

    <!-- Control Sidebar -->
    <aside class="control-sidebar control-sidebar-dark">
      <!-- Control sidebar content goes here -->
    </aside>
    <!-- /.control-sidebar -->
  </div>
  <!-- ./wrapper -->
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
  <!-- overlayScrollbars -->
  <script src="plugins/overlayScrollbars/js/jquery.overlayScrollbars.min.js"></script>
  <!-- AdminLTE App -->
  <script src="dist/js/adminlte.js"></script>


  ​
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

    /** Các biến toàn cục hằng số Form mode: 4 trạng thái của form. Mặc định sẽ là Normal
   *
   ** Khi ấn vào nút Thêm, cần đổi biến trạng thái về trạng thái Insert
   ** Khi ấn vào nút Sửa, cần đổi biến trạng thái về trạng thái Update
   ** Khi ấn vào nút Xóa, cần đổi biến trạng thái về trạng thái Delete
   *
   * Tại một thời điểm, trạng thái của form luôn là 1 trong 4 trạng thái
   */
    var gFORM_MODE_NORMAL = "Normal";
    var gFORM_MODE_INSERT = "Insert";
    var gFORM_MODE_UPDATE = "Update";
    var gFORM_MODE_DELETE = "Delete";

    // biến toàn cục cho trạng thái của form: mặc định ban đầu là trạng thái Normal
    var gFormMode = gFORM_MODE_NORMAL;

    // Biến toàn cục để lưu trữ id voucher đang đc update or delete. Mặc định = 0;
    var gVoucherId = 0;

    // mảng chứa dữ liệu vouchers
    var gVoucherObjects = [
      {
        "id": 10,
        "voucherCode": "12456",
        "discount": 20
      },
      {
        "id": 13,
        "voucherCode": "15678",
        "discount": 10
      },
      {
        "id": 14,
        "voucherCode": "34215",
        "discount": 15
      },
      {
        "id": 16,
        "voucherCode": "12785",
        "discount": 15
      },
      {
        "id": 17,
        "voucherCode": "13785",
        "discount": 10
      },
      {
        "id": 18,
        "voucherCode": "10385",
        "discount": 20
      }
    ];

    // Biến mảng hằng số chứa danh sách tên các thuộc tính
    const gVOUCHER_COLS = ["stt", "id", "voucherCode", "discount", "action"];

    // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
    const gVOUCHER_STT_COL = 0;
    const gVOUCHER_ID_COL = 1;
    const gVOUCHER_VOUCHER_CODE_COL = 2;
    const gVOUCHER_DISCOUNT_COL = 3;
    const gVOUCHER_ACTION_COL = 4;

    // Biến toàn cục để hiển lưu STT
    var gSTT = 1;
    // Khai báo DataTable & mapping collumns
    var gVoucherTable = $("#voucher-table").DataTable({
      columns: [
        { data: gVOUCHER_COLS[gVOUCHER_STT_COL] },
        { data: gVOUCHER_COLS[gVOUCHER_ID_COL] },
        { data: gVOUCHER_COLS[gVOUCHER_VOUCHER_CODE_COL] },
        { data: gVOUCHER_COLS[gVOUCHER_DISCOUNT_COL] },
        { data: gVOUCHER_COLS[gVOUCHER_ACTION_COL] }
      ],
      columnDefs: [
        { // định nghĩa lại cột STT
          targets: gVOUCHER_STT_COL,
          render: function () {
            return gSTT++;
          }
        },
        { // định nghĩa lại cột action
          targets: gVOUCHER_ACTION_COL,
          defaultContent: `
          <img class="edit-voucher" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
          <img class="delete-voucher" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
        `
        }
      ]
    });

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    onPageLoading();

    // 2 - C: gán sự kiện Create - Thêm mới voucher
    $("#btn-add-voucher").on("click", function () {
      onBtnAddNewVoucherClick();
    });
    // 3 - U: gán sự kiện Update - Sửa 1 voucher
    $("#voucher-table").on("click", ".edit-voucher", function () {
      onIconEditVoucherClick(this);
    });

    // 4 - D: gán sự kiện Delete - Xóa 1 voucher
    $("#voucher-table").on("click", ".delete-voucher", function () {
      onIconDeleteVoucherClick(this);
    });

    //thêm sự kiện cho nút save voucher trên modal form udapte/insert
    $("#btn-save-voucher").on("click", function () {
      onBtnSaveVoucherClick();
    });

    //thêm sự kiện cho nút delete voucher trên modal form delete
    $("#btn-confirm-delete-voucher").on("click", function () {
      onBtnDeleteVoucherClick();
    });

    // thêm sự kiện reset data khi ẩn modal form insert/update
    $("#voucher-modal").on("hidden.bs.modal", function () {
      resetFormData();
    });

    // thêm sự kiện reset data khi ẩn modal form delete
    $("#delete-confirm-modal").on("hidden.bs.modal", function () {
      resetFormData();
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // hàm thực thi khi trang được load
    function onPageLoading() {
      // 1 - R: Read / Load voucher to DataTable
      loadDataToVoucherTable(gVoucherObjects);
      // hiển thị formMode
      $("#div-form-mod").html(gFormMode);
    }

    // Hàm xử lý sự kiện khi nút Thêm mới đc click
    function onBtnAddNewVoucherClick() {
      // chuyển đổi trạng thái form về insert
      gFormMode = gFORM_MODE_INSERT;
      $("#div-form-mod").html(gFormMode);
      // hiển thị modal trắng lên
      $("#voucher-modal").modal("show");
    }

    // Hàm xử lý sự kiện khi icon edit voucher trên bảng đc click
    function onIconEditVoucherClick(paramIconEdit) {
      // chuyển đổi trạng thái form về update
      gFormMode = gFORM_MODE_UPDATE;
      $("#div-form-mod").html(gFormMode);
      // lưu thông tin voucherId đang được edit vào biến toàn cục
      gVoucherId = getIdDataFromButton(paramIconEdit);
      // load dữ liệu vào các trường dữ liệu trong modal
      showVoucherDataToModal(gVoucherId);
      // hiển thị modal lên
      $("#voucher-modal").modal("show");
    }

    // Hàm xử lý sự kiện khi icon delete voucher trên bảng đc click
    function onIconDeleteVoucherClick(paramIconEdit) {
      // chuyển đổi trạng thái form về update
      gFormMode = gFORM_MODE_DELETE;
      $("#div-form-mod").html(gFormMode);
      // lưu thông tin voucherId đang được edit vào biến toàn cục
      gVoucherId = getIdDataFromButton(paramIconEdit);
      // hiển thị modal lên
      $("#delete-confirm-modal").modal("show");
    }

    //hàm xử lý sự kiện save voucher
    function onBtnSaveVoucherClick() {
      //B0: khai báo biến
      var vVoucherObj = {
        id: 0,
        voucherCode: "",
        discount: 0
      }

      //B1: thu thập dữ liệu
      getVoucherData(vVoucherObj);

      //B2: kiểm tra dữ liệu
      var vIsValidate = validateData(vVoucherObj);

      if (vIsValidate) {
        //B3: xử lý dữ liệu (insert/update)
        saveVoucherData(vVoucherObj);

        //B4: hiển thị kết quả
        loadDataToVoucherTable(gVoucherObjects);
        //thông báo
        alert("Cập nhật dữ liệu thành công");
        //ẩn modal form
        $("#voucher-modal").modal('hide');
        //reset dữ liệu
        resetFormData();
      }
    }

    //hàm xử lý sự kiện delete voucher
    function onBtnDeleteVoucherClick() {
      //B0: khai báo biến (bỏ qua)
      //B1: thu thập dữ liệu (bỏ qua)
      //B2: kiểm tra dữ liệu (bỏ qua)
      //B3: xử lý dữ liệu (delete)
      deleteVoucherData();
      //B4: hiển thị kết quả
      loadDataToVoucherTable(gVoucherObjects);
      //thông báo
      alert("Xóa dữ liệu thành công");
      //reset dữ liệu
      resetFormData();
      //ẩn modal form
      $("#delete-confirm-modal").modal('hide');
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    /** load voucher array to DataTable
     * in: voucher array
     * out: voucher table has data
     */
    function loadDataToVoucherTable(paramVoucherArr) {
      gSTT = 1;
      gVoucherTable.clear();
      gVoucherTable.rows.add(paramVoucherArr);
      gVoucherTable.draw();
    }

    // hàm thu thập dữ liệu trên form update/insert voucher
    function getVoucherData(paramVoucherObj) {
      //thu thập id
      if (gFormMode === gFORM_MODE_INSERT) {//thêm mới
        paramVoucherObj.id = getNextId();
      } else {
        paramVoucherObj.id = gVoucherId;
      }

      //code
      paramVoucherObj.voucherCode = $("#input-voucher-code").val().trim();

      //discount
      paramVoucherObj.discount = parseInt($("#input-discount").val().trim());
    }

    // hàm validate data
    function validateData(paramVoucherObj) {
      if (paramVoucherObj.voucherCode === "") {
        alert("Voucher code cần nhập");
        return false;
      }

      if (paramVoucherObj.discount === "") {
        alert("Discount cần nhập");
        return false;
      }

      if (isNaN(paramVoucherObj.discount) || paramVoucherObj.discount < 0 || paramVoucherObj.discount > 100) {
        alert("Discount không hợp lệ");
        return false;
      }

      if (isExistVoucherCode(paramVoucherObj.voucherCode)) {
        alert("Mã Voucher bị trùng");
        return false;
      }

      return true;
    }

    // hàm kiểm tra trung mã voucher
    function isExistVoucherCode(paramVoucherCode) {
      var vIsFound = false;
      var vIndex = 0;
      while (!vIsFound && vIndex < gVoucherObjects.length) {
        if (gFormMode === gFORM_MODE_INSERT) {//thêm mới => không được phép trung với bất kỳ 1 dòng nào
          if (gVoucherObjects[vIndex].voucherCode === paramVoucherCode) {
            vIsFound = true;
          } else {
            vIndex++;
          }
        } else {//update: không được phép trùng với các dòng khác dòng hiện tại
          if (gVoucherObjects[vIndex].voucherCode === paramVoucherCode && gVoucherObjects[vIndex].id != gVoucherId) {
            vIsFound = true;
          } else {
            vIndex++;
          }
        }
      }

      return vIsFound;
    }

    // hàm cập nhật voucher vào database
    function saveVoucherData(paramVoucherObj) {
      if (gFormMode === gFORM_MODE_INSERT) {//insert
        gVoucherObjects.push(paramVoucherObj);
      } else {//update
        var bVoucherIndex = getIndexFormVoucherId(paramVoucherObj.id);
        gVoucherObjects.splice(bVoucherIndex, 1, paramVoucherObj);
        /*
              gVoucherObjects[bVoucherIndex].id = paramVoucherObj.id;
              gVoucherObjects[bVoucherIndex].voucherCode = paramVoucherObj.voucherCode;
              gVoucherObjects[bVoucherIndex].discount = paramVoucherObj.discount;*/
      }
    }

    // hàm xóa voucher khỏi database
    function deleteVoucherData() {
      var vVoucherIndex = getIndexFormVoucherId(gVoucherId);
      gVoucherObjects.splice(vVoucherIndex, 1);
    }

    // get voucher index from voucher id
    // input: paramVoucherId là voucherId cần tìm index
    // output: trả về chỉ số (index) trong mảng voucher
    function getIndexFormVoucherId(paramVoucherId) {
      var vVoucherIndex = -1;
      var vVoucherFound = false;
      var vLoopIndex = 0;
      while (!vVoucherFound && vLoopIndex < gVoucherObjects.length) {
        if (gVoucherObjects[vLoopIndex].id === paramVoucherId) {
          vVoucherIndex = vLoopIndex;
          vVoucherFound = true;
        }
        else {
          vLoopIndex++;
        }
      }
      return vVoucherIndex;
    }

    // hàm lấy ra đc id voucher tiếp theo, dùng khi thêm mới voucher
    function getNextId() {
      var vNextId = 0;
      // nếu mảng chưa có phần tử nào, thì id sẽ bắt đầu từ 1
      if (gVoucherObjects.length == 0) {
        vNextId = 1;
      }
      else { // id tiếp theo bằng id của phần tử cuối cùng cộng thêm 1
        vNextId = gVoucherObjects[gVoucherObjects.length - 1].id + 1;
      }
      return vNextId;
    }

    // hàm dựa vào button detail (edit or delete) xác định đc id voucher
    function getIdDataFromButton(paramIcon) {
      var vTableRow = $(paramIcon).parents("tr");
      var vVoucherRowData = gVoucherTable.row(vTableRow).data();
      return vVoucherRowData.id;
    }

    // hàm show voucher obj lên modal
    function showVoucherDataToModal(paramVoucherId) {
      var vVoucherIndex = getIndexFormVoucherId(paramVoucherId);
      $("#input-voucher-code").val(gVoucherObjects[vVoucherIndex].voucherCode);
      $("#input-discount").val(gVoucherObjects[vVoucherIndex].discount);
    }

    // hàm reset dữ liệu
    function resetFormData() {
      //update trạng thái
      gFormMode = gFORM_MODE_NORMAL;
      $("#div-form-mod").html(gFormMode);

      gVoucherId = 0;
      $("#input-voucher-code").val("");
      $("#input-discount").val("");
    }
  </script>
</body>

</html>